;;==========================================================================
;;   VLSI
;; DREQ    B.0
;;

.dseg
vlsi_Time:	.byte	2	;   
;vlsi_Head:	.byte	4	;   (ASCII):    
vlsi_V_L:	.byte	1	;   (  Vol  Pan)
vlsi_V_R:	.byte	1	;   (  Vol  Pan)
vlsi_Dirt:	.byte	1	;      EEPROM

vlsi_Vol:	.byte	1	; 	[Vol, Pan, Mode    f_IO]
vlsi_Pan:	.byte	1	; 
vlsi_Mode:	.byte	1	;    [     SM_DIFF]
vlsi_Ton:	.byte	2	;   


;   SM_MODE (0x00)
.equ	vlsi_SM_DIFF	= 0	;  
.equ	vlsi_SM_LAY12	= 1	;  MPEG layer I & II
.equ	vlsi_SM_RESET	= 2	;  .    VLSI 

;	OUTOFWAV == 0		- "     WAV-,
;     1   ,    ģ"

.equ	vlsi_SM_TESTS	= 5	;     SDI

;	STREAM == 0		-    ,  
;      VLSI   
; ,      .
;	DACT == 0		-   SDI
;	SDIORD == 0		-   SDI
;	SDISHARE == 0		-  CS  

.equ	vlsi_SM_SDINEW	= 11	; !!   "1"     SPI !!


.eseg
nv_vlsi_VolMod:	.byte	5	;    EEPROM,  vlsi_Init,  vlsi_Close  vlsi_Dirt = 1


.cseg
;
;    / r18..r19  r17 VLSI
;
vlsi_CRead:
 rcall	vlsi_WaitDREQ
 ldi	r16, spi_CSCLK_VLSI_SCI	; !CS = 0
 rcall	spi_CSCLK_Select

 ldi	r16, 0x03		;   
 rcall	spi_IO

 mov	r16, r17
 rcall	spi_IO			;   

 rcall	spi_IO
 mov	r19, r16
 rcall	spi_IO
 mov	r18, r16
 rjmp	vlsi_CIO_1

vlsi_CWrite:
 rcall	vlsi_WaitDREQ
 ldi	r16, spi_CSCLK_VLSI_SCI	; !CS = 0
 rcall	spi_CSCLK_Select

 ldi	r16, 0x02		;   
 rcall	spi_IO

 mov	r16, r17
 rcall	spi_IO			;   

 mov	r16, r19
 rcall	spi_IO
 mov	r16, r18
 rcall	spi_IO

vlsi_CIO_1:
 ldi	r16, spi_CSCLK_release	; !CS = 1 -      (   VLSI)
 rjmp	spi_CSCLK_Select

;
;   VLSI  
;
vlsi_WaitDREQ:
 sbis	PINB, 0			;   VLSI
 rjmp	vlsi_WaitDREQ
	; ldi	r25, 0xc2
	; sleep
	; call	SendByte
 ret

;
;   Z+  SDI
;
vlsi_SendBuf:
 ldi	r16, spi_CSCLK_VLSI_SDI
 rcall	spi_CSCLK_Select
 clr	r17

vlsi_SB_1:
 call	vlsi_WaitDREQ

 ld	r16, Z+
 rcall	spi_IO

 ld	r16, Z+
 rcall	spi_IO

 dec	r17
 brne	vlsi_SB_1

 rjmp	vlsi_CIO_1

;
;   VLSI [  ]
;
vlsi_Init:
 sbi	DDRB, 1			;   VLSI
 cbi	PORTB, 1
 call	Wait1mks
 sbi	PORTB, 1

 rcall	f_IO			;  , ,    DIFF
.db	f_ORead, 5
.dw	nv_vlsi_VolMod
.dw	vlsi_Vol

 clr	r16			;    ,   
 sts	vlsi_Dirt, r16

 rcall	vlsi_CalcVol		; Vol, Pan -> V_L, V_R

 lds	r16, vlsi_Mode
 andi	r16, (1<<vlsi_SM_DIFF)
 sts	vlsi_Mode, r16

 rjmp	Wait2ms			;  FAQ - 1 ms (...  RESET    CBUS  DBUS)
				;   datasheet ,  DREQ    
				;     50000 * XTAL,      24.576
				;   2 ms....

;
;  VLSI  power down
;
vlsi_Sleep:
 ldi	r16, 0xFF
 sts	vlsi_V_L, r16
 sts	vlsi_V_R, r16
 rcall	vlsi_SetTones

 cbi	PORTB, 1		;   !RESET,      
 ret

;
;   VLSI [  ]
;   r20 :
; 0 - Ok
; 1 - DREQ    
; 2 - DREQ    
; 3 -  SW_RESET     
;
vlsi_Open:
 clr	r17
 ldi	r19, (1<<(vlsi_SM_SDINEW-8))
 ldi	r18, (1<<vlsi_SM_RESET)
 rcall	vlsi_CWrite

 rcall	Wait5mks		;  datasheet  2 mks,   FAQ - 5 mks

 ldi	r20, 2			; DREQ       == "0"
 sbic	PINB, 0			;    # 2
 ret

 rcall	Wait2ms			;  datasheet  250 mks,  FAQ - 1000 mks

 ldi	r20, 1			;   250 mks DREQ   == "1"
 sbis	PINB, 0			;    # 1
vlsi_O_1:
 ret

 ldi	r20, 3
 clr	r17
 rcall	vlsi_CRead		;   ,  SM_RESET   "0"
 andi	r18, (1<<vlsi_SM_RESET)
 brne	vlsi_O_1		;    # 3

 clr	r20			;  ӣ  ,     SDI
 ldi	r16, spi_CSCLK_VLSI_SDI	;   # 0     
 rcall	spi_CSCLK_Select

 clr	r16
 rcall	spi_IO
 clr	r16
 rcall	spi_IO			;  datasheet   ,  FAQ - 2

;
;   VLSI (, , ...)
;
vlsi_SetTones:
 clr	r17			; Mode
 ldi	r19, (1<<(vlsi_SM_SDINEW-8))
 lds	r18, vlsi_Mode
 andi	r18, (1<<vlsi_SM_DIFF)
 rcall	vlsi_CWrite

 ldi	r17, 0x02		; Tone
 lds	r18, vlsi_Ton+0
 lds	r19, vlsi_Ton+1
 rcall	vlsi_CWrite

 ldi	r17, 0x0b		; Volume
 lds	r19, vlsi_V_L
 lds	r18, vlsi_V_R
 rjmp	vlsi_CWrite

;
;   VLSI [  ]
;
vlsi_GetState:
 ldi	r17, 0x04		; Time
 rcall	vlsi_CRead
 sts	vlsi_Time+0, r18
 sts	vlsi_Time+1, r19
 ret

;
;        AUDATA  HDAT
;
vlsi_HDAT_print:

; AUDATA: samplerate +  

 ldi	r16, 0x80
 rcall	lcd_SetAttr
 ldi	r17, 1
 rcall	lcd_GoToLine

 rcall	lcd_Print
.db	"Sample rate: ", 1

 ldi	r17, 0x05
 rcall	vlsi_CRead

 ldi	r25, 'm'
 sbrc	r18, 0
 ldi	r25, 's'
 andi	r18, 0xFE
 movw	dd16uL, r18
 rcall	lcd_CharOut
 rcall	DecWordOut

 rcall	lcd_ClrEol

; HDAT...

 ldi	r17, 0x08
 rcall	vlsi_CRead
 movw	r8, r18		; HDAT0
 ldi	r17, 0x09
 rcall	vlsi_CRead
 movw	r10, r18	; HDAT1

; HDAT: ID / Layer

 clr	r16
 rcall	lcd_SetAttr
 ldi	r17, 2
 rcall	lcd_GoToLine

 rcall	lcd_Print
.db	"MPEG ", 1


 mov	r19, r10		; I, II, III
 lsr	r19
 andi	r19, 0x03
vlsi_HDp_2:
 ldi	r25, 'I'
 rcall	lcd_CharOut
 inc	r19
 cpi	r19, 4
 brne	vlsi_HDp_2


 rcall	lcd_Print
.db	" v", 1


 mov	r16, r10		; 1.0, 2.0, 2.5
 andi	r16, 0x18
 ldi	r25, '2'
 cpi	r16, 0x18
 brne	vlsi_HDp_1
 ldi	r25, '1'
vlsi_HDp_1:
 rcall	lcd_CharOut

 ldi	r25, '.'
 rcall	lcd_CharOut

 ldi	r25, '0'
 sbrs	r10, 4
 ldi	r25, '5'
 rcall	lcd_CharOut


 rcall	lcd_Print
.db	", ", 1


 mov	r16, r8
 andi	r16, 0xC0
 breq	vlsi_HDp_cn00
 cpi	r16, 0x40
 breq	vlsi_HDp_cn01
 cpi	r16, 0x80
 breq	vlsi_HDp_cn10

vlsi_HDp_cn11:
 rcall	lcd_Print
.db	"mono", 1
 rjmp	vlsi_HDp_6

vlsi_HDp_cn10:
 rcall	lcd_Print
.db	"d/chan", 1
 rjmp	vlsi_HDp_6

vlsi_HDp_cn01:
 rcall	lcd_Print
.db	"j/stereo", 1
 rjmp	vlsi_HDp_6

vlsi_HDp_cn00:
 rcall	lcd_Print
.db	"stereo", 1

vlsi_HDp_6:
 rcall	lcd_ClrEol

; HDAT: Sample rate

 ldi	r17, 3
 rcall	lcd_GoToLine

 rcall	lcd_Print
.db	"Sample rate: ", 1
	
				; "xxxxx"
 ldi	ZL, low(vlsi_HDp_table1*2)
 ldi	ZH, high(vlsi_HDp_table1*2)
 mov	r17, r9
 andi	r17, 0x0C
 lsr	r17
 clr	r18
 add	ZL, r17
 adc	ZH, r18
 lpm	dd16uL, Z+
 lpm	dd16uH, Z+

 mov	r18, r10
 andi	r18, 0x18
 lsr	r18
 lsr	r18
 lsr	r18

vlsi_HDp_5:
 cpi	r18, 2
 brlo	vlsi_HDp_3
 lsl	dd16uL
 rol	dd16uH
 dec	r18
 rjmp	vlsi_HDp_5

vlsi_HDp_3:
 rcall	DecWordOut


 rcall	lcd_ClrEol

; HDAT: Bit rate

 ldi	r17, 4
 rcall	lcd_GoToLine

 rcall	lcd_Print
.db	"Bit rate: ", 1

 mov	r17, r10	; LayerID*2
 andi	r17, 0x06
 subi	r17, 2
 lsl	r17		; *4
 lsl	r17		; *8
 lsl	r17		; *16
 lsl	r17		; *32
 
 mov	r16, r9		; r16 = bitrate
 swap	r16
 andi	r16, 0x0F

 add	r16, r17	; r16 += 32 * (LayerID-1)

 sbrs	r10, 4		; if ID = 3 then r16 += 16
 rjmp	vlsi_HDp_4
 sbrc	r10, 3
 subi	r16, -(16)
vlsi_HDp_4:

 ldi	ZL, low(vlsi_HDp_table2*2)
 ldi	ZH, high(vlsi_HDp_table2*2)
 clr	r17
 add	ZL, r16
 adc	ZH, r17

 lpm	dd16uL, Z
 clr	dd16uH
 lsl	dd16uL
 rol	dd16uH
 rcall	DecWordOut

 rcall	lcd_ClrEol

;

 ldi	r17, 5
 rcall	lcd_GoToLine

 movw	dd16uL, r8
 rcall	DecWordOut
 ldi	r25, '/'
 rcall	lcd_CharOut
 movw	dd16uL, r10
 rcall	DecWordOut

 rjmp	lcd_ClrEol

;

vlsi_HDp_table1:
.dw	11025, 12000, 8000, 1

vlsi_HDp_table2:
; LayerID = 1; Layer III
.db 	0, 8/2, 16/2, 24/2, 32/2, 40/2, 48/2, 56/2, 64/2, 80/2, 96/2, 112/2, 128/2, 144/2, 160/2, 0		; ID = 0, 1, 2
.db	0, 32/2, 40/2, 48/2, 56/2, 64/2, 80/2, 96/2, 112/2, 128/2, 160/2, 192/2, 224/2, 256/2, 320/2, 0		; ID = 3
; LayerID = 2; Layer II
.db	0, 8/2, 16/2, 24/2, 32/2, 40/2, 48/2, 56/2, 64/2, 80/2, 96/2, 112/2, 128/2, 144/2, 160/2, 0		; ID = 0, 1, 2
.db	0, 32/2, 48/2, 56/2, 64/2, 80/2, 96/2, 112/2, 128/2, 160/2, 192/2, 224/2, 256/2, 320/2, 384/2, 0	; ID = 3
; LayerID = 3; Layer I
.db	0, 32/2, 48/2, 56/2, 64/2, 80/2, 96/2, 112/2, 128/2, 144/2, 160/2, 176/2, 192/2, 224/2, 256/2, 0	; ID = 0, 1, 2
.db	0, 32/2, 64/2, 96/2, 128/2, 160/2, 192/2, 224/2, 256/2, 288/2, 320/2, 352/2, 384/2, 416/2, 448/2, 0	; ID = 3

;
;    r16    r17,  
;     vlsi_CalcVol  vlsi_SetTones
;
vlsi_ChVol:
 mov	r18, r16
 or	r18, r17
 breq	vlsi_ret

 lds	r18, vlsi_Vol
 lds	r19, vlsi_Pan

 tst	r16
 brmi	vlsi_CV_3

 add	r18, r16		;  
 brcc	vlsi_CV_4
 ldi	r18, 0xFF		;  
 rjmp	vlsi_CV_4

vlsi_CV_3:
 add	r18, r16		;  
 brcs	vlsi_CV_4
 ldi	r18, 0x00		;  

vlsi_CV_4:
 add	r19, r17		;    

 sts	vlsi_Vol, r18
 sts	vlsi_Pan, r19

 ldi	r16, 1			;    ,    EEPROM
 sts	vlsi_Dirt, r16

 rcall	vlsi_CalcVol
 rjmp	vlsi_SetTones

;
;  V_L, V_R  Vol  Pan
; 
vlsi_CalcVol:
 lds	r18, vlsi_Vol
 mov	r19, r18

 lds	r16, vlsi_Pan
 tst	r16
 breq	vlsi_CV_1

 brmi	vlsi_CV_2

 add	r18, r16		;  ,  
 brcc	vlsi_CV_1
 ldi	r18, 0xFF		;   
 rjmp	vlsi_CV_1

vlsi_CV_2:
 sub	r19, r16		;  ,  
 brcs	vlsi_CV_1
 ldi	r19, 0xFF		;   

vlsi_CV_1:
 sts	vlsi_V_L, r18
 sts	vlsi_V_R, r19
vlsi_ret:
 ret

;
;   
; [ 2048   SDI   50 ms]
;    EEPROM /,  
;
vlsi_Close:
 lds	r16, vlsi_Dirt
 tst	r16
 breq	vlsi_C_2
 
 rcall	f_IO			;  , ,    DIFF
.db	f_OWrite, 5
.dw	nv_vlsi_VolMod
.dw	vlsi_Vol

 clr	r16			;    ,   
 sts	vlsi_Dirt, r16

 sec
 rcall	lcd_PrintC
.db	"Volume saved ", 1

vlsi_C_2:
 ldi	r16, spi_CSCLK_VLSI_SDI
 rcall	spi_CSCLK_Select
 ldi	r17, 8			; 256 * 8 = 2048
 clr	r18

vlsi_C_1:
 rcall	vlsi_WaitDREQ

 clr	r16
 rcall	spi_IO

 dec	r18
 brne	vlsi_C_1
 dec	r17
 brne	vlsi_C_1
 rjmp	Wait50ms
