Const
  XK_BackSpace		= $FF08; // back space, back char
  XK_Tab		= $FF09;
  XK_Linefeed		= $FF0A; // Linefeed, LF
  XK_Clear		= $FF0B;
  XK_Return		= $FF0D; // Return, enter
  XK_Pause		= $FF13; // Pause, hold
  XK_Scroll_Lock	= $FF14;
  XK_Sys_Req		= $FF15;
  XK_Escape		= $FF1B;
  XK_Delete		= $FFFF; // Delete, rubout

  XK_Home		= $FF50;
  XK_Left		= $FF51; // Move left, left arrow
  XK_Up			= $FF52; // Move up, up arrow
  XK_Right		= $FF53; // Move right, right arrow
  XK_Down		= $FF54; // Move down, down arrow
  XK_Prior		= $FF55; // Prior, previous
  XK_Page_Up		= $FF55;
  XK_Next		= $FF56; // Next
  XK_Page_Down		= $FF56;
  XK_End		= $FF57; // EOL
  XK_Begin		= $FF58; // BOL

  XK_Print		= $FF61; // Print [SysRq-Shift]
  XK_Insert		= $FF63; // Insert
  XK_Break		= $FF6B; // Break [Pause+Shift]

  XK_KP_Space		= $FF80; // space
  XK_KP_Tab		= $FF89;
  XK_KP_Enter		= $FF8D; // enter
  XK_KP_F1		= $FF91; // PF1, KP_A, ...
  XK_KP_F2		= $FF92;
  XK_KP_F3		= $FF93;
  XK_KP_F4		= $FF94;
  XK_KP_Home		= $FF95;
  XK_KP_Left		= $FF96;
  XK_KP_Up		= $FF97;
  XK_KP_Right		= $FF98;
  XK_KP_Down		= $FF99;
  XK_KP_Prior		= $FF9A;
  XK_KP_Page_Up		= $FF9A;
  XK_KP_Next		= $FF9B;
  XK_KP_Page_Down	= $FF9B;
  XK_KP_End		= $FF9C;
  XK_KP_Begin		= $FF9D;
  XK_KP_Insert		= $FF9E;
  XK_KP_Delete		= $FF9F;
  XK_KP_Equal		= $FFBD; // equals
  XK_KP_Multiply	= $FFAA;
  XK_KP_Add		= $FFAB;
  XK_KP_Separator	= $FFAC; // separator, often comma
  XK_KP_Subtract	= $FFAD;
  XK_KP_Decimal		= $FFAE;
  XK_KP_Divide		= $FFAF;

  XK_KP_0		= $FFB0;
  XK_KP_1		= $FFB1;
  XK_KP_2		= $FFB2;
  XK_KP_3		= $FFB3;
  XK_KP_4		= $FFB4;
  XK_KP_5		= $FFB5;
  XK_KP_6		= $FFB6;
  XK_KP_7		= $FFB7;
  XK_KP_8		= $FFB8;
  XK_KP_9		= $FFB9;

  XK_F1			= $FFBE;
  XK_F2			= $FFBF;
  XK_F3			= $FFC0;
  XK_F4			= $FFC1;
  XK_F5			= $FFC2;
  XK_F6			= $FFC3;
  XK_F7			= $FFC4;
  XK_F8			= $FFC5;
  XK_F9			= $FFC6;
  XK_F10		= $FFC7;
  XK_F11		= $FFC8;
  XK_L1			= $FFC8;
  XK_F12		= $FFC9;
  XK_L2			= $FFC9;
  XK_F13		= $FFCA;
  XK_L3			= $FFCA;
  XK_F14		= $FFCB;
  XK_L4			= $FFCB;
  XK_F15		= $FFCC;
  XK_L5			= $FFCC;
  XK_F16		= $FFCD;
  XK_L6			= $FFCD;
  XK_F17		= $FFCE;
  XK_L7			= $FFCE;
  XK_F18		= $FFCF;
  XK_L8			= $FFCF;
  XK_F19		= $FFD0;
  XK_L9			= $FFD0;
  XK_F20		= $FFD1;
  XK_L10		= $FFD1;
  XK_F21		= $FFD2;
  XK_R1			= $FFD2;
  XK_F22		= $FFD3;
  XK_R2			= $FFD3;
  XK_F23		= $FFD4;
  XK_R3			= $FFD4;
  XK_F24		= $FFD5;
  XK_R4			= $FFD5;
  XK_F25		= $FFD6;
  XK_R5			= $FFD6;
  XK_F26		= $FFD7;
  XK_R6			= $FFD7;
  XK_F27		= $FFD8;
  XK_R7			= $FFD8;
  XK_F28		= $FFD9;
  XK_R8			= $FFD9;
  XK_F29		= $FFDA;
  XK_R9			= $FFDA;
  XK_F30		= $FFDB;
  XK_R10		= $FFDB;
  XK_F31		= $FFDC;
  XK_R11		= $FFDC;
  XK_F32		= $FFDD;
  XK_R12		= $FFDD;
  XK_F33		= $FFDE;
  XK_R13		= $FFDE;
  XK_F34		= $FFDF;
  XK_R14		= $FFDF;
  XK_F35		= $FFE0;
  XK_R15		= $FFE0;

  XK_Shift_L		= $FFE1; // Left shift
  XK_Shift_R		= $FFE2; // Right shift
  XK_Control_L		= $FFE3; // Left control
  XK_Control_R		= $FFE4; // Right control
  XK_Caps_Lock		= $FFE5; // Caps lock
  XK_Shift_Lock		= $FFE6; // Shift lock

  XK_Meta_L		= $FFE7; // Left meta
  XK_Meta_R		= $FFE8; // Right meta
  XK_Alt_L		= $FFE9; // Left alt
  XK_Alt_R		= $FFEA; // Right alt
  XK_Super_L		= $FFEB; // Left super
  XK_Super_R		= $FFEC; // Right super
  XK_Hyper_L		= $FFED; // Left hyper
  XK_Hyper_R		= $FFEE; // Right hyper
